       IDENTIFICATION DIVISION.                                                 
MACGEN PROGRAM-ID. SAMPCIPN.                                            

MACGEN AUTHOR. RDZ.
MACGEN INSTALLATION. 8.1.0.V20090916_1613.
MACGEN DATE-WRITTEN. 11/4/09 11:30 AM.
MACGEN************************************************************
MACGEN* GENERATED NAVIGATOR MODULE - SAMPCIPN
MACGEN************************************************************
MACGEN* PROJECT: CatalogSample
MACGEN* FLOW: CheckItemAvailability.seqflow
MACGEN* GENERATION PROPERTIES: CheckItemAvailabilityGP.sfgen
MACGEN************************************************************                                                                
      *********************** DFHMAL20 *********************************        
      * @START_RRS_COPYRIGHT@                                                   
      * VERSION: 1                                                              
      *                                                                         
      * Licensed Materials - Property of IBM                                    
      *                                                                         
      * 5655-M15                                                                
      *                                                                         
      * (C) Copyright IBM Corp. 2000, 2005                                      
      * @END_RRS_COPYRIGHT@                                                     
      ******************************************************************        
       ENVIRONMENT DIVISION.                                                    
       CONFIGURATION SECTION.                                                   
       SOURCE-COMPUTER.  IBM-370.                                               
       OBJECT-COMPUTER.  IBM-370.                                               
       DATA DIVISION.                                                           
       WORKING-STORAGE SECTION.                                                 
       01  WS-COMMAND-DEFINITION.                                               
MACGEN     05  WS-PROGRAM-ID       PIC X(08) VALUE 'SAMPCIPN'.          
MACGEN     05  WS-TRANSACTION-ID   PIC X(04) VALUE 'SADI'.           
           05  WS-PROGRAM-TYPE     PIC S9(8) COMP VALUE +5.                     
           05  WS-NODE-NAME        PIC X(32) VALUE SPACES.                      
           COPY DFHMAL31.                                                       
           COPY DFHMAL2C.                                                       
       01  NAVIGATOR-OUTPUT-AREA.                                               
MACGEN     COPY OCHECKIT.
                                                             
       01  ACTIVITY-IO-AREA.                                                    
           02  MAP-BUFFER          PIC X(32000).                                
        02 LINK3270-REQUEST-0 REDEFINES MAP-BUFFER.
MACGEN     COPY EXMENU.
        02 LINK3270-REQUEST-1 REDEFINES MAP-BUFFER.
MACGEN     COPY ENDPAGE.
        02 LINK3270-REQUEST-2 REDEFINES MAP-BUFFER.
MACGEN     COPY EXINQC.
                                                             
       01  DECISION-IO-AREA.                                                    
MACGEN     COPY VCHECKIT.
                                                           
       01  ITERATION-IO-AREA.                                                   
MACGEN     02  DUMMY  PIC X(8) VALUE 'DFHDUMMY'.
                                                          
       01  LOCAL-CONTEXT-AREA.                                                  
MACGEN     02  DUMMY  PIC X(8) VALUE 'DFHDUMMY'.
                                                           
       01  SHARED-CONTEXT-AREA.                                                 
MACGEN     02  DUMMY  PIC X(8) VALUE 'DFHDUMMY'.
                                                          
       01  JOURNAL-CONTEXT-AREA.                                                
MACGEN     02  DUMMY  PIC X(8) VALUE 'DFHDUMMY'.
                                                         
       LINKAGE SECTION.                                                         
           COPY DFHMAMAC.                                                       
       01  INPUT-DATA-CONTAINER.                                                
MACGEN     COPY ICHECKIT.
                                                              
           COPY DFHMAMOC.                                                       
       PROCEDURE DIVISION.                                                      
           COPY DFHMAL22.                                                       

MACGEN* InTerminal i_CheckItemAvailability
MACGEN* Copybook Name: ICHECKIT.CPY
MACGEN* Message Data Structure: I-CHECKITEMAVAILABILITY

MACGEN     MOVE DFHCLEAR TO SNA-INITIAL-AID-BYTE.
MACGEN     MOVE 'EGUI' TO SNA-CICSMACRO-SCREEN.
MACGEN     MOVE DFHENTER TO SNA-AID-BYTE.
      ******************************************************************        
      *  LINK3270 BRIDGE NAVIGATOR PROCEDURE DIVISION COPYBOOK                  
      ******************************************************************        
      *********************** DFHMAL25 *********************************        
      * @START_RRS_COPYRIGHT@                                                   
      * VERSION: 0                                                              
      *                                                                         
      * Licensed Materials - Property of IBM                                    
      *                                                                         
      * 5655-M15                                                                
      *                                                                         
      * (C) Copyright IBM Corp. 2000, 2005                                      
      * @END_RRS_COPYRIGHT@                                                     
      ******************************************************************        
                                                                                
MACGEN* Previous line must remain blank for generation                          
MACGEN* Screen Command - %MAT_PROGRAM                                          
                                                                                
MACGEN     MOVE +5 TO NSC-CHILD-TYPE.                               
                                                                                
MACGEN     MOVE 1 TO TRANSLATE-MAP-TO-HOST.
MACGEN     MOVE 'Y' TO SEND-PFKEY-FIRST.
MACGEN     MOVE 'N' TO SNA-COUNT-FIELDS.
MACGEN     MOVE ' ' TO SNA-CALCULATE-CHECKSUM.
MACGEN     SET SNA-REQUIRED-ADS TO TRUE.                                                   
                                                                                
      
      ************** START: SFMTRACE code ******************************
           MOVE SPACES TO WS-TRACE-ENTRY.
MACGEN     SET LINK3270-TRACE-RESOURCE  TO TRUE.
           STRING "REQUEST: ", ADC-MAH-REQUESTNAME DELIMITED BY SIZE
                  " PROGRAM: ", WS-PROGRAM-ID DELIMITED BY SIZE
                  " NODE: ", WS-TRACE-RESOURCE DELIMITED BY SIZE
MACGEN            " ACTIVITY: ", 'EGUI' 
                       DELIMITED BY SIZE
                INTO WS-TRACE-ENTRY.
           EXEC CICS ENTER TRACENUM(104)
                           RESOURCE(WS-TRACE-RESOURCEID)
                           FROM(WS-TRACE-ENTRY)
                           FROMLENGTH(LENGTH OF WS-TRACE-ENTRY)
                           NOHANDLE
           END-EXEC. 
      ************** TRAILER: SFMTRACE *********************************


           PERFORM 4000-SEND-RECEIVE-RTN                                        
              THRU 4000-SEND-RECEIVE-EXIT.                                      
                                                                                
           MOVE SNA-VECTOR-DATA TO MAP-BUFFER.                                  
                                                                                

MACGEN*  Screen recognition logic 
MACGEN     IF SNA-3270-MAP-NAME    = 'EXMENU' AND 
MACGEN        SNA-3270-MAPSET-NAME = 'DFH0XS1' 
MACGEN        MOVE 'EXMENU' TO CSC-RESULT-NAME
MACGEN        MOVE LENGTH OF EXMENU
MACGEN                    TO WS-COC-LENGTH
MACGEN     ELSE
MACGEN        MOVE 'UNKNOWN' TO CSC-RESULT-NAME
MACGEN        MOVE 24000 TO WS-COC-LENGTH.                                                    
                                                                                
           IF WS-COC-LENGTH > WS-MAX-DC-LENGTH                                  
               MOVE WS-MAX-DC-LENGTH TO WS-COC-LENGTH.                          
                                                                                
           IF CSC-RESULT-NAME NOT EQUAL 'UNKNOWN'                               
               MOVE MAP-BUFFER  TO SNA-VECTOR-DATA.                             
                                                                                
           MOVE WS-COC-LENGTH   TO SNA-BUFFER-LENGTH                            
                                   WS-ODC-LENGTH                                
                                   ADC-ODC-LENGTH.                              
           SET ADDRESS OF OUTPUT-DATA-CONTAINER                                 
            TO ADDRESS OF SNA-VECTOR-DATA.    
      * End of Screen Command                                                   
                                                                                
      ************** TRAILER: DFHMAL25 *********************************        
                                                                                

MACGEN     IF CSC-RESULT-NAME = 'UNKNOWN' THEN 
MACGEN       MOVE 'EXIT' TO NSC-RESULT-NAME
MACGEN       PERFORM 9000-NAVIGATOR-EXIT
MACGEN     END-IF.

MACGEN* Mapping: variableAssignInput

MACGEN* Mapping: Dfh0xs1.Exmenu_Exmenu
MACGEN     
MACGEN     COMPUTE SNA-CURPOS = 442.
MACGEN     
MACGEN     MOVE DFHENTER TO SNA-AID-BYTE.
MACGEN     
MACGEN     MOVE '1' TO ACTIONI OF EXMENU
MACGEN     MOVE LENGTH OF ACTIONI OF EXMENU TO
                ACTIONL OF EXMENU.
MACGEN     MOVE EXMENU
MACGEN          TO SNA-VECTOR-DATA.
      ******************************************************************        
      *  LINK3270 BRIDGE NAVIGATOR PROCEDURE DIVISION COPYBOOK                  
      ******************************************************************        
      *********************** DFHMAL25 *********************************        
      * @START_RRS_COPYRIGHT@                                                   
      * VERSION: 0                                                              
      *                                                                         
      * Licensed Materials - Property of IBM                                    
      *                                                                         
      * 5655-M15                                                                
      *                                                                         
      * (C) Copyright IBM Corp. 2000, 2005                                      
      * @END_RRS_COPYRIGHT@                                                     
      ******************************************************************        
                                                                                
MACGEN* Previous line must remain blank for generation                          
MACGEN* Screen Command - DFH0XS1-                                          
                                                                                
MACGEN     MOVE +5 TO NSC-CHILD-TYPE.                               
                                                                                
MACGEN     MOVE 1 TO TRANSLATE-MAP-TO-HOST.
MACGEN     MOVE 'N' TO SEND-PFKEY-FIRST.
MACGEN     MOVE 'N' TO SNA-COUNT-FIELDS.
MACGEN     MOVE ' ' TO SNA-CALCULATE-CHECKSUM.
MACGEN     SET SNA-REQUIRED-ADS TO TRUE.                                                   
                                                                                
      
      ************** START: SFMTRACE code ******************************
           MOVE SPACES TO WS-TRACE-ENTRY.
MACGEN     SET LINK3270-TRACE-RESOURCE  TO TRUE.
           STRING "REQUEST: ", ADC-MAH-REQUESTNAME DELIMITED BY SIZE
                  " PROGRAM: ", WS-PROGRAM-ID DELIMITED BY SIZE
                  " NODE: ", WS-TRACE-RESOURCE DELIMITED BY SIZE
MACGEN            " ACTIVITY: ", 'Dfh0xs1.Exmenu_Exmenu' 
                       DELIMITED BY SIZE
                INTO WS-TRACE-ENTRY.
           EXEC CICS ENTER TRACENUM(104)
                           RESOURCE(WS-TRACE-RESOURCEID)
                           FROM(WS-TRACE-ENTRY)
                           FROMLENGTH(LENGTH OF WS-TRACE-ENTRY)
                           NOHANDLE
           END-EXEC. 
      ************** TRAILER: SFMTRACE *********************************


           PERFORM 4000-SEND-RECEIVE-RTN                                        
              THRU 4000-SEND-RECEIVE-EXIT.                                      
                                                                                
           MOVE SNA-VECTOR-DATA TO MAP-BUFFER.                                  
                                                                                

MACGEN*  Screen recognition logic 
MACGEN     IF SNA-3270-MAP-NAME    = 'EXINQC' AND 
MACGEN        SNA-3270-MAPSET-NAME = 'DFH0XS2' 
MACGEN     
MACGEN     AND (
MACGEN     (INQC-MSGI
MACGEN     OF ENDPAGE (1:11) = 
           'END OF DATA')
MACGEN     )
MACGEN        MOVE 'ENDPAGE' TO CSC-RESULT-NAME
MACGEN        MOVE LENGTH OF ENDPAGE
MACGEN                    TO WS-COC-LENGTH
MACGEN     ELSE
MACGEN     IF SNA-3270-MAP-NAME    = 'EXINQC' AND 
MACGEN        SNA-3270-MAPSET-NAME = 'DFH0XS2' 
MACGEN     
MACGEN     AND (
MACGEN     (INQC-MSGI
MACGEN     OF EXINQC = SPACES OR LOW-VALUES)
MACGEN     )
MACGEN        MOVE 'EXINQC' TO CSC-RESULT-NAME
MACGEN        MOVE LENGTH OF EXINQC
MACGEN                    TO WS-COC-LENGTH
MACGEN     ELSE
MACGEN        MOVE 'UNKNOWN' TO CSC-RESULT-NAME
MACGEN        MOVE 24000 TO WS-COC-LENGTH.                                                    
                                                                                
           IF WS-COC-LENGTH > WS-MAX-DC-LENGTH                                  
               MOVE WS-MAX-DC-LENGTH TO WS-COC-LENGTH.                          
                                                                                
           IF CSC-RESULT-NAME NOT EQUAL 'UNKNOWN'                               
               MOVE MAP-BUFFER  TO SNA-VECTOR-DATA.                             
                                                                                
           MOVE WS-COC-LENGTH   TO SNA-BUFFER-LENGTH                            
                                   WS-ODC-LENGTH                                
                                   ADC-ODC-LENGTH.                              
           SET ADDRESS OF OUTPUT-DATA-CONTAINER                                 
            TO ADDRESS OF SNA-VECTOR-DATA.    
      * End of Screen Command                                                   
                                                                                
      ************** TRAILER: DFHMAL25 *********************************        
                                                                                

MACGEN     IF CSC-RESULT-NAME = 'ENDPAGE' THEN 
MACGEN       PERFORM 1010-PARAGRAPH THRU 1010-PARAGRAPH-EXIT
MACGEN     ELSE
MACGEN     IF CSC-RESULT-NAME = 'EXINQC' THEN 
MACGEN       PERFORM 1050-PARAGRAPH THRU 1050-PARAGRAPH-EXIT
MACGEN     ELSE
MACGEN       MOVE 'EXIT' TO NSC-RESULT-NAME
MACGEN       PERFORM 9000-NAVIGATOR-EXIT
MACGEN     END-IF.

                                                                
           COPY DFHMAL23.                                                       
----->* END MAIN RTN / START SUB RTN *<-----

       1010-PARAGRAPH.
      ******************************************************************        
      *  LINK3270 BRIDGE NAVIGATOR PROCEDURE DIVISION COPYBOOK                  
      ******************************************************************        
      *********************** DFHMAL25 *********************************        
      * @START_RRS_COPYRIGHT@                                                   
      * VERSION: 0                                                              
      *                                                                         
      * Licensed Materials - Property of IBM                                    
      *                                                                         
      * 5655-M15                                                                
      *                                                                         
      * (C) Copyright IBM Corp. 2000, 2005                                      
      * @END_RRS_COPYRIGHT@                                                     
      ******************************************************************        
                                                                                
MACGEN* Previous line must remain blank for generation                          
MACGEN* Screen Command - CHECKITE                                          
                                                                                
MACGEN     MOVE +5 TO NSC-CHILD-TYPE.                               
                                                                                
MACGEN     MOVE 0 TO TRANSLATE-MAP-TO-HOST.
MACGEN     MOVE 'N' TO SEND-PFKEY-FIRST.
MACGEN     MOVE 'N' TO SNA-COUNT-FIELDS.
MACGEN     MOVE ' ' TO SNA-CALCULATE-CHECKSUM.
MACGEN     SET SNA-REQUIRED-ADS TO TRUE.                                                   
                                                                                
      
      ************** START: SFMTRACE code ******************************
           MOVE SPACES TO WS-TRACE-ENTRY.
MACGEN     SET LINK3270-TRACE-RESOURCE  TO TRUE.
           STRING "REQUEST: ", ADC-MAH-REQUESTNAME DELIMITED BY SIZE
                  " PROGRAM: ", WS-PROGRAM-ID DELIMITED BY SIZE
                  " NODE: ", WS-TRACE-RESOURCE DELIMITED BY SIZE
MACGEN            " ACTIVITY: ", 'parse_variable0' 
                       DELIMITED BY SIZE
                INTO WS-TRACE-ENTRY.
           EXEC CICS ENTER TRACENUM(104)
                           RESOURCE(WS-TRACE-RESOURCEID)
                           FROM(WS-TRACE-ENTRY)
                           FROMLENGTH(LENGTH OF WS-TRACE-ENTRY)
                           NOHANDLE
           END-EXEC. 
      ************** TRAILER: SFMTRACE *********************************


           PERFORM 4000-SEND-RECEIVE-RTN                                        
              THRU 4000-SEND-RECEIVE-EXIT.                                      
                                                                                
           MOVE SNA-VECTOR-DATA TO MAP-BUFFER.                                  
                                                                                

MACGEN*  Screen recognition logic 
MACGEN     IF SNA-3270-MAP-NAME    = 'EXINQC' AND 
MACGEN        SNA-3270-MAPSET-NAME = 'DFH0XS2' 
MACGEN     
MACGEN     AND (
MACGEN     (INQC-MSGI
MACGEN     OF ENDPAGE (1:11) = 
           'END OF DATA')
MACGEN     )
MACGEN        MOVE 'ENDPAGE' TO CSC-RESULT-NAME
MACGEN        MOVE LENGTH OF ENDPAGE
MACGEN                    TO WS-COC-LENGTH
MACGEN     ELSE
MACGEN        MOVE 'UNKNOWN' TO CSC-RESULT-NAME
MACGEN        MOVE 24000 TO WS-COC-LENGTH.                                                    
                                                                                
           IF WS-COC-LENGTH > WS-MAX-DC-LENGTH                                  
               MOVE WS-MAX-DC-LENGTH TO WS-COC-LENGTH.                          
                                                                                
           IF CSC-RESULT-NAME NOT EQUAL 'UNKNOWN'                               
               MOVE MAP-BUFFER  TO SNA-VECTOR-DATA.                             
                                                                                
           MOVE WS-COC-LENGTH   TO SNA-BUFFER-LENGTH                            
                                   WS-ODC-LENGTH                                
                                   ADC-ODC-LENGTH.                              
           SET ADDRESS OF OUTPUT-DATA-CONTAINER                                 
            TO ADDRESS OF SNA-VECTOR-DATA.    
      * End of Screen Command                                                   
                                                                                
      ************** TRAILER: DFHMAL25 *********************************        
                                                                                

MACGEN     IF CSC-RESULT-NAME = 'ENDPAGE' THEN 
MACGEN       PERFORM 1020-PARAGRAPH THRU 1020-PARAGRAPH-EXIT
MACGEN     ELSE
MACGEN       MOVE 'EXIT' TO NSC-RESULT-NAME
MACGEN       PERFORM 9000-NAVIGATOR-EXIT
MACGEN     END-IF.

       1010-PARAGRAPH-EXIT.
MACGEN     EXIT.

       1020-PARAGRAPH.

MACGEN* Mapping: parse_variable0

MACGEN* Mapping: Dfh0xs2.Exinqc_EndPage
MACGEN     
MACGEN     COMPUTE SNA-CURPOS = 542.
MACGEN     
MACGEN     MOVE DFHPF12 TO SNA-AID-BYTE.
MACGEN     MOVE ENDPAGE
MACGEN          TO SNA-VECTOR-DATA.
      ******************************************************************        
      *  LINK3270 BRIDGE NAVIGATOR PROCEDURE DIVISION COPYBOOK                  
      ******************************************************************        
      *********************** DFHMAL25 *********************************        
      * @START_RRS_COPYRIGHT@                                                   
      * VERSION: 0                                                              
      *                                                                         
      * Licensed Materials - Property of IBM                                    
      *                                                                         
      * 5655-M15                                                                
      *                                                                         
      * (C) Copyright IBM Corp. 2000, 2005                                      
      * @END_RRS_COPYRIGHT@                                                     
      ******************************************************************        
                                                                                
MACGEN* Previous line must remain blank for generation                          
MACGEN* Screen Command - DFH0XS2-                                          
                                                                                
MACGEN     MOVE +5 TO NSC-CHILD-TYPE.                               
                                                                                
MACGEN     MOVE 1 TO TRANSLATE-MAP-TO-HOST.
MACGEN     MOVE 'N' TO SEND-PFKEY-FIRST.
MACGEN     MOVE 'N' TO SNA-COUNT-FIELDS.
MACGEN     MOVE ' ' TO SNA-CALCULATE-CHECKSUM.
MACGEN     SET SNA-REQUIRED-ADS TO TRUE.                                                   
                                                                                
      
      ************** START: SFMTRACE code ******************************
           MOVE SPACES TO WS-TRACE-ENTRY.
MACGEN     SET LINK3270-TRACE-RESOURCE  TO TRUE.
           STRING "REQUEST: ", ADC-MAH-REQUESTNAME DELIMITED BY SIZE
                  " PROGRAM: ", WS-PROGRAM-ID DELIMITED BY SIZE
                  " NODE: ", WS-TRACE-RESOURCE DELIMITED BY SIZE
MACGEN            " ACTIVITY: ", 'Dfh0xs2.Exinqc_EndPage' 
                       DELIMITED BY SIZE
                INTO WS-TRACE-ENTRY.
           EXEC CICS ENTER TRACENUM(104)
                           RESOURCE(WS-TRACE-RESOURCEID)
                           FROM(WS-TRACE-ENTRY)
                           FROMLENGTH(LENGTH OF WS-TRACE-ENTRY)
                           NOHANDLE
           END-EXEC. 
      ************** TRAILER: SFMTRACE *********************************


           PERFORM 4000-SEND-RECEIVE-RTN                                        
              THRU 4000-SEND-RECEIVE-EXIT.                                      
                                                                                
           MOVE SNA-VECTOR-DATA TO MAP-BUFFER.                                  
                                                                                

MACGEN*  Screen recognition logic 
MACGEN     IF SNA-3270-MAP-NAME    = 'EXMENU' AND 
MACGEN        SNA-3270-MAPSET-NAME = 'DFH0XS1' 
MACGEN        MOVE 'EXMENU' TO CSC-RESULT-NAME
MACGEN        MOVE LENGTH OF EXMENU
MACGEN                    TO WS-COC-LENGTH
MACGEN     ELSE
MACGEN        MOVE 'UNKNOWN' TO CSC-RESULT-NAME
MACGEN        MOVE 24000 TO WS-COC-LENGTH.                                                    
                                                                                
           IF WS-COC-LENGTH > WS-MAX-DC-LENGTH                                  
               MOVE WS-MAX-DC-LENGTH TO WS-COC-LENGTH.                          
                                                                                
           IF CSC-RESULT-NAME NOT EQUAL 'UNKNOWN'                               
               MOVE MAP-BUFFER  TO SNA-VECTOR-DATA.                             
                                                                                
           MOVE WS-COC-LENGTH   TO SNA-BUFFER-LENGTH                            
                                   WS-ODC-LENGTH                                
                                   ADC-ODC-LENGTH.                              
           SET ADDRESS OF OUTPUT-DATA-CONTAINER                                 
            TO ADDRESS OF SNA-VECTOR-DATA.    
      * End of Screen Command                                                   
                                                                                
      ************** TRAILER: DFHMAL25 *********************************        
                                                                                

MACGEN     IF CSC-RESULT-NAME = 'EXMENU' THEN 
MACGEN       PERFORM 1030-PARAGRAPH THRU 1030-PARAGRAPH-EXIT
MACGEN     ELSE
MACGEN       MOVE 'EXIT' TO NSC-RESULT-NAME
MACGEN       PERFORM 9000-NAVIGATOR-EXIT
MACGEN     END-IF.

       1020-PARAGRAPH-EXIT.
MACGEN     EXIT.

       1030-PARAGRAPH.

MACGEN* Mapping: Dfh0xs2.Exinqc_EndPage

MACGEN     PERFORM 1040-PARAGRAPH THRU 1040-PARAGRAPH-EXIT.
       1030-PARAGRAPH-EXIT.
MACGEN     EXIT.

       1040-PARAGRAPH.

MACGEN* Mapping: variableAssignOutput
MACGEN     
MACGEN     MOVE AVAILABLE OF
                V-CHECKITEMAVAILABILITY TO AVAILABLE OF
                O-CHECKITEMAVAILABILITY.

MACGEN* Reply: o_CheckItemAvailability
MACGEN* Copybook Name: OCHECKIT.CPY
MACGEN* Message Data Structure: O-CHECKITEMAVAILABILITY
      *********************** DFHMAN07 *********************************        
      * @START_RRS_COPYRIGHT@                                                   
      * VERSION: 0                                                              
      *                                                                         
      * Licensed Materials - Property of IBM                                    
      *                                                                         
      * 5655-M15                                                                
      *                                                                         
      * (C) Copyright IBM Corp. 2000, 2005                                      
      * @END_RRS_COPYRIGHT@                                                     
      ******************************************************************        
MACGEN     MOVE LENGTH OF O-CHECKITEMAVAILABILITY                                        
                                         TO WS-ODC-LENGTH                       
                                            ADC-ODC-LENGTH.                     
           SET ADDRESS OF OUTPUT-DATA-CONTAINER                                 
MACGEN      TO ADDRESS OF O-CHECKITEMAVAILABILITY.                                       
MACGEN     MOVE 'OCHECKIT'                                              
                            TO NSC-RESULT-NAME.                                 
MACGEN     MOVE '        '                                           
                            TO NSC-XML-PROGRAMID.                               
           IF WS-PROGRAM-TYPE EQUAL ZERO  AND                                   
              ASYNC-REQUEST                                                     
               PERFORM 9000-NAVIGATOR-EXIT.                                     
                                                                                
      ************** TRAILER: DFHMAN07 *********************************        
                                                                                

       1040-PARAGRAPH-EXIT.
MACGEN     EXIT.

       1050-PARAGRAPH.

MACGEN* Mapping: Dfh0xs1.Exmenu_Exmenu

MACGEN* Mapping: init_variable0
MACGEN     
MACGEN     MOVE 'TRUE' TO VARIABLE0 OF
                V-CHECKITEMAVAILABILITY.

MACGEN     PERFORM 1060-PARAGRAPH THRU 1060-PARAGRAPH-EXIT.
       1050-PARAGRAPH-EXIT.
MACGEN     EXIT.

       1060-PARAGRAPH.

MACGEN* While: while_variable0
MACGEN     IF NOT(  (VARIABLE0 OF V-CHECKITEMAVAILABILITY = 'TRUE') ) 
MACGEN       PERFORM 1070-PARAGRAPH THRU 1070-PARAGRAPH-EXIT
MACGEN     ELSE
MACGEN       PERFORM 1080-PARAGRAPH THRU 1080-PARAGRAPH-EXIT.
MACGEN     IF NAVIGATOR-GOOD  OR  ASYNC-REQUEST
MACGEN       PERFORM 9000-NAVIGATOR-EXIT
MACGEN     ELSE
MACGEN       PERFORM 9010-NAVIGATOR-RETURN.
       1060-PARAGRAPH-EXIT.
MACGEN     EXIT.

       1070-PARAGRAPH.

MACGEN* Switch: cAvailable
MACGEN     IF   NOT ((AVAILABLE OF V-CHECKITEMAVAILABILITY =
                'YES'))
MACGEN       PERFORM 1010-PARAGRAPH THRU 1010-PARAGRAPH-EXIT
MACGEN      ELSE
MACGEN       PERFORM 1040-PARAGRAPH THRU 1040-PARAGRAPH-EXIT
MACGEN      END-IF.

       1070-PARAGRAPH-EXIT.
MACGEN     EXIT.

       1080-PARAGRAPH.

MACGEN* InTerminal while_variable0_InTerminal.Start
      ******************************************************************        
      *  LINK3270 BRIDGE NAVIGATOR PROCEDURE DIVISION COPYBOOK                  
      ******************************************************************        
      *********************** DFHMAL25 *********************************        
      * @START_RRS_COPYRIGHT@                                                   
      * VERSION: 0                                                              
      *                                                                         
      * Licensed Materials - Property of IBM                                    
      *                                                                         
      * 5655-M15                                                                
      *                                                                         
      * (C) Copyright IBM Corp. 2000, 2005                                      
      * @END_RRS_COPYRIGHT@                                                     
      ******************************************************************        
                                                                                
MACGEN* Previous line must remain blank for generation                          
MACGEN* Screen Command - CHECKITE                                          
                                                                                
MACGEN     MOVE +5 TO NSC-CHILD-TYPE.                               
                                                                                
MACGEN     MOVE 0 TO TRANSLATE-MAP-TO-HOST.
MACGEN     MOVE 'N' TO SEND-PFKEY-FIRST.
MACGEN     MOVE 'N' TO SNA-COUNT-FIELDS.
MACGEN     MOVE ' ' TO SNA-CALCULATE-CHECKSUM.
MACGEN     SET SNA-REQUIRED-ADS TO TRUE.                                                   
                                                                                
      
      ************** START: SFMTRACE code ******************************
           MOVE SPACES TO WS-TRACE-ENTRY.
MACGEN     SET LINK3270-TRACE-RESOURCE  TO TRUE.
           STRING "REQUEST: ", ADC-MAH-REQUESTNAME DELIMITED BY SIZE
                  " PROGRAM: ", WS-PROGRAM-ID DELIMITED BY SIZE
                  " NODE: ", WS-TRACE-RESOURCE DELIMITED BY SIZE
MACGEN            " ACTIVITY: ", 'Dfh0xs2.Exinqc_ExinqcInitialExtract' 
                       DELIMITED BY SIZE
                INTO WS-TRACE-ENTRY.
           EXEC CICS ENTER TRACENUM(104)
                           RESOURCE(WS-TRACE-RESOURCEID)
                           FROM(WS-TRACE-ENTRY)
                           FROMLENGTH(LENGTH OF WS-TRACE-ENTRY)
                           NOHANDLE
           END-EXEC. 
      ************** TRAILER: SFMTRACE *********************************


           PERFORM 4000-SEND-RECEIVE-RTN                                        
              THRU 4000-SEND-RECEIVE-EXIT.                                      
                                                                                
           MOVE SNA-VECTOR-DATA TO MAP-BUFFER.                                  
                                                                                

MACGEN*  Screen recognition logic 
MACGEN     IF SNA-3270-MAP-NAME    = 'EXINQC' AND 
MACGEN        SNA-3270-MAPSET-NAME = 'DFH0XS2' 
MACGEN     
MACGEN     AND (
MACGEN     (INQC-MSGI
MACGEN     OF EXINQC = SPACES OR LOW-VALUES)
MACGEN     )
MACGEN        MOVE 'EXINQC' TO CSC-RESULT-NAME
MACGEN        MOVE LENGTH OF EXINQC
MACGEN                    TO WS-COC-LENGTH
MACGEN     ELSE
MACGEN        MOVE 'UNKNOWN' TO CSC-RESULT-NAME
MACGEN        MOVE 24000 TO WS-COC-LENGTH.                                                    
                                                                                
           IF WS-COC-LENGTH > WS-MAX-DC-LENGTH                                  
               MOVE WS-MAX-DC-LENGTH TO WS-COC-LENGTH.                          
                                                                                
           IF CSC-RESULT-NAME NOT EQUAL 'UNKNOWN'                               
               MOVE MAP-BUFFER  TO SNA-VECTOR-DATA.                             
                                                                                
           MOVE WS-COC-LENGTH   TO SNA-BUFFER-LENGTH                            
                                   WS-ODC-LENGTH                                
                                   ADC-ODC-LENGTH.                              
           SET ADDRESS OF OUTPUT-DATA-CONTAINER                                 
            TO ADDRESS OF SNA-VECTOR-DATA.    
      * End of Screen Command                                                   
                                                                                
      ************** TRAILER: DFHMAL25 *********************************        
                                                                                

MACGEN     IF CSC-RESULT-NAME = 'EXINQC' THEN 
MACGEN       PERFORM 1090-PARAGRAPH THRU 1090-PARAGRAPH-EXIT
MACGEN     ELSE
MACGEN       MOVE 'EXIT' TO NSC-RESULT-NAME
MACGEN       PERFORM 9000-NAVIGATOR-EXIT
MACGEN     END-IF.

       1080-PARAGRAPH-EXIT.
MACGEN     EXIT.

       1090-PARAGRAPH.

MACGEN* Mapping: Dfh0xs2.Exinqc_ExinqcInitialExtract
MACGEN     
MACGEN      IF INQ15-ITEMREFI OF EXINQC NOT EQUAL
                SPACES AND LOW-VALUES  THEN 
MACGEN     MOVE INQ15-ITEMREFI OF EXINQC TO
                INQ15-ITEMREF OF V-CHECKITEMAVAILABILITY
MACGEN      END-IF .
MACGEN     
MACGEN      IF INQ14-ITEMREFI OF EXINQC NOT EQUAL
                SPACES AND LOW-VALUES  THEN 
MACGEN     MOVE INQ14-ITEMREFI OF EXINQC TO
                INQ14-ITEMREF OF V-CHECKITEMAVAILABILITY
MACGEN      END-IF .
MACGEN     
MACGEN      IF INQ13-ITEMREFI OF EXINQC NOT EQUAL
                SPACES AND LOW-VALUES  THEN 
MACGEN     MOVE INQ13-ITEMREFI OF EXINQC TO
                INQ13-ITEMREF OF V-CHECKITEMAVAILABILITY
MACGEN      END-IF .
MACGEN     
MACGEN      IF INQ12-ITEMREFI OF EXINQC NOT EQUAL
                SPACES AND LOW-VALUES  THEN 
MACGEN     MOVE INQ12-ITEMREFI OF EXINQC TO
                INQ12-ITEMREF OF V-CHECKITEMAVAILABILITY
MACGEN      END-IF .
MACGEN     
MACGEN      IF INQ11-ITEMREFI OF EXINQC NOT EQUAL
                SPACES AND LOW-VALUES  THEN 
MACGEN     MOVE INQ11-ITEMREFI OF EXINQC TO
                INQ11-ITEMREF OF V-CHECKITEMAVAILABILITY
MACGEN      END-IF .
MACGEN     
MACGEN      IF INQ10-ITEMREFI OF EXINQC NOT EQUAL
                SPACES AND LOW-VALUES  THEN 
MACGEN     MOVE INQ10-ITEMREFI OF EXINQC TO
                INQ10-ITEMREF OF V-CHECKITEMAVAILABILITY
MACGEN      END-IF .
MACGEN     
MACGEN      IF INQ9-ITEMREFI OF EXINQC NOT EQUAL
                SPACES AND LOW-VALUES  THEN 
MACGEN     MOVE INQ9-ITEMREFI OF EXINQC TO
                INQ9-ITEMREF OF V-CHECKITEMAVAILABILITY
MACGEN      END-IF .
MACGEN     
MACGEN      IF INQ8-ITEMREFI OF EXINQC NOT EQUAL
                SPACES AND LOW-VALUES  THEN 
MACGEN     MOVE INQ8-ITEMREFI OF EXINQC TO
                INQ8-ITEMREF OF V-CHECKITEMAVAILABILITY
MACGEN      END-IF .
MACGEN     
MACGEN      IF INQ7-ITEMREFI OF EXINQC NOT EQUAL
                SPACES AND LOW-VALUES  THEN 
MACGEN     MOVE INQ7-ITEMREFI OF EXINQC TO
                INQ7-ITEMREF OF V-CHECKITEMAVAILABILITY
MACGEN      END-IF .
MACGEN     
MACGEN      IF INQ6-ITEMREFI OF EXINQC NOT EQUAL
                SPACES AND LOW-VALUES  THEN 
MACGEN     MOVE INQ6-ITEMREFI OF EXINQC TO
                INQ6-ITEMREF OF V-CHECKITEMAVAILABILITY
MACGEN      END-IF .
MACGEN     
MACGEN      IF INQ5-ITEMREFI OF EXINQC NOT EQUAL
                SPACES AND LOW-VALUES  THEN 
MACGEN     MOVE INQ5-ITEMREFI OF EXINQC TO
                INQ5-ITEMREF OF V-CHECKITEMAVAILABILITY
MACGEN      END-IF .
MACGEN     
MACGEN      IF INQ4-ITEMREFI OF EXINQC NOT EQUAL
                SPACES AND LOW-VALUES  THEN 
MACGEN     MOVE INQ4-ITEMREFI OF EXINQC TO
                INQ4-ITEMREF OF V-CHECKITEMAVAILABILITY
MACGEN      END-IF .
MACGEN     
MACGEN      IF INQ3-ITEMREFI OF EXINQC NOT EQUAL
                SPACES AND LOW-VALUES  THEN 
MACGEN     MOVE INQ3-ITEMREFI OF EXINQC TO
                INQ3-ITEMREF OF V-CHECKITEMAVAILABILITY
MACGEN      END-IF .
MACGEN     
MACGEN      IF INQ2-ITEMREFI OF EXINQC NOT EQUAL
                SPACES AND LOW-VALUES  THEN 
MACGEN     MOVE INQ2-ITEMREFI OF EXINQC TO
                INQ2-ITEMREF OF V-CHECKITEMAVAILABILITY
MACGEN      END-IF .
MACGEN     
MACGEN      IF INQ1-ITEMREFI OF EXINQC NOT EQUAL
                SPACES AND LOW-VALUES  THEN 
MACGEN     MOVE INQ1-ITEMREFI OF EXINQC TO
                INQ1-ITEMREF OF V-CHECKITEMAVAILABILITY
MACGEN      END-IF .

MACGEN* Switch: Switch
MACGEN     IF  (((((((((((((((ITEMNUMBER OF
                I-CHECKITEMAVAILABILITY = INQ1-ITEMREF OF
                V-CHECKITEMAVAILABILITY) OR (ITEMNUMBER OF
                I-CHECKITEMAVAILABILITY = INQ2-ITEMREF OF
                V-CHECKITEMAVAILABILITY)) OR (ITEMNUMBER OF
                I-CHECKITEMAVAILABILITY = INQ3-ITEMREF OF
                V-CHECKITEMAVAILABILITY)) OR (ITEMNUMBER OF
                I-CHECKITEMAVAILABILITY = INQ4-ITEMREF OF
                V-CHECKITEMAVAILABILITY)) OR (ITEMNUMBER OF
                I-CHECKITEMAVAILABILITY = INQ5-ITEMREF OF
                V-CHECKITEMAVAILABILITY)) OR (ITEMNUMBER OF
                I-CHECKITEMAVAILABILITY = INQ6-ITEMREF OF
                V-CHECKITEMAVAILABILITY)) OR (ITEMNUMBER OF
                I-CHECKITEMAVAILABILITY = INQ7-ITEMREF OF
                V-CHECKITEMAVAILABILITY)) OR (ITEMNUMBER OF
                I-CHECKITEMAVAILABILITY = INQ8-ITEMREF OF
                V-CHECKITEMAVAILABILITY)) OR (ITEMNUMBER OF
                I-CHECKITEMAVAILABILITY = INQ9-ITEMREF OF
                V-CHECKITEMAVAILABILITY)) OR (ITEMNUMBER OF
                I-CHECKITEMAVAILABILITY = INQ10-ITEMREF OF
                V-CHECKITEMAVAILABILITY)) OR (ITEMNUMBER OF
                I-CHECKITEMAVAILABILITY = INQ11-ITEMREF OF
                V-CHECKITEMAVAILABILITY)) OR (ITEMNUMBER OF
                I-CHECKITEMAVAILABILITY = INQ12-ITEMREF OF
                V-CHECKITEMAVAILABILITY)) OR (ITEMNUMBER OF
                I-CHECKITEMAVAILABILITY = INQ13-ITEMREF OF
                V-CHECKITEMAVAILABILITY)) OR (ITEMNUMBER OF
                I-CHECKITEMAVAILABILITY = INQ14-ITEMREF OF
                V-CHECKITEMAVAILABILITY)) OR (ITEMNUMBER OF
                I-CHECKITEMAVAILABILITY = INQ15-ITEMREF OF
                V-CHECKITEMAVAILABILITY))
MACGEN       PERFORM 1100-PARAGRAPH THRU 1100-PARAGRAPH-EXIT
MACGEN      ELSE
MACGEN       PERFORM 1110-PARAGRAPH THRU 1110-PARAGRAPH-EXIT
MACGEN      END-IF.

       1090-PARAGRAPH-EXIT.
MACGEN     EXIT.

       1100-PARAGRAPH.

MACGEN* Mapping: Assign
MACGEN     
MACGEN     MOVE 'FALSE' TO VARIABLE0 OF
                V-CHECKITEMAVAILABILITY.
MACGEN     
MACGEN     MOVE 'YES' TO AVAILABLE OF
                V-CHECKITEMAVAILABILITY.

MACGEN     PERFORM 1060-PARAGRAPH THRU 1060-PARAGRAPH-EXIT.
       1100-PARAGRAPH-EXIT.
MACGEN     EXIT.

       1110-PARAGRAPH.

MACGEN* Mapping: Dfh0xs2.Exinqc_Exinqc
MACGEN     
MACGEN     COMPUTE SNA-CURPOS = 542.
MACGEN     
MACGEN     MOVE DFHPF8 TO SNA-AID-BYTE.
MACGEN     MOVE EXINQC
MACGEN          TO SNA-VECTOR-DATA.
      ******************************************************************        
      *  LINK3270 BRIDGE NAVIGATOR PROCEDURE DIVISION COPYBOOK                  
      ******************************************************************        
      *********************** DFHMAL25 *********************************        
      * @START_RRS_COPYRIGHT@                                                   
      * VERSION: 0                                                              
      *                                                                         
      * Licensed Materials - Property of IBM                                    
      *                                                                         
      * 5655-M15                                                                
      *                                                                         
      * (C) Copyright IBM Corp. 2000, 2005                                      
      * @END_RRS_COPYRIGHT@                                                     
      ******************************************************************        
                                                                                
MACGEN* Previous line must remain blank for generation                          
MACGEN* Screen Command - DFH0XS2-                                          
                                                                                
MACGEN     MOVE +5 TO NSC-CHILD-TYPE.                               
                                                                                
MACGEN     MOVE 1 TO TRANSLATE-MAP-TO-HOST.
MACGEN     MOVE 'N' TO SEND-PFKEY-FIRST.
MACGEN     MOVE 'N' TO SNA-COUNT-FIELDS.
MACGEN     MOVE ' ' TO SNA-CALCULATE-CHECKSUM.
MACGEN     SET SNA-REQUIRED-ADS TO TRUE.                                                   
                                                                                
      
      ************** START: SFMTRACE code ******************************
           MOVE SPACES TO WS-TRACE-ENTRY.
MACGEN     SET LINK3270-TRACE-RESOURCE  TO TRUE.
           STRING "REQUEST: ", ADC-MAH-REQUESTNAME DELIMITED BY SIZE
                  " PROGRAM: ", WS-PROGRAM-ID DELIMITED BY SIZE
                  " NODE: ", WS-TRACE-RESOURCE DELIMITED BY SIZE
MACGEN            " ACTIVITY: ", 'Dfh0xs2.Exinqc_Exinqc' 
                       DELIMITED BY SIZE
                INTO WS-TRACE-ENTRY.
           EXEC CICS ENTER TRACENUM(104)
                           RESOURCE(WS-TRACE-RESOURCEID)
                           FROM(WS-TRACE-ENTRY)
                           FROMLENGTH(LENGTH OF WS-TRACE-ENTRY)
                           NOHANDLE
           END-EXEC. 
      ************** TRAILER: SFMTRACE *********************************


           PERFORM 4000-SEND-RECEIVE-RTN                                        
              THRU 4000-SEND-RECEIVE-EXIT.                                      
                                                                                
           MOVE SNA-VECTOR-DATA TO MAP-BUFFER.                                  
                                                                                

MACGEN*  Screen recognition logic 
MACGEN     IF SNA-3270-MAP-NAME    = 'EXINQC' AND 
MACGEN        SNA-3270-MAPSET-NAME = 'DFH0XS2' 
MACGEN     
MACGEN     AND (
MACGEN     (INQC-MSGI
MACGEN     OF ENDPAGE (1:11) = 
           'END OF DATA')
MACGEN     )
MACGEN        MOVE 'ENDPAGE' TO CSC-RESULT-NAME
MACGEN        MOVE LENGTH OF ENDPAGE
MACGEN                    TO WS-COC-LENGTH
MACGEN     ELSE
MACGEN     IF SNA-3270-MAP-NAME    = 'EXINQC' AND 
MACGEN        SNA-3270-MAPSET-NAME = 'DFH0XS2' 
MACGEN     
MACGEN     AND (
MACGEN     (INQC-MSGI
MACGEN     OF EXINQC = SPACES OR LOW-VALUES)
MACGEN     )
MACGEN        MOVE 'EXINQC' TO CSC-RESULT-NAME
MACGEN        MOVE LENGTH OF EXINQC
MACGEN                    TO WS-COC-LENGTH
MACGEN     ELSE
MACGEN        MOVE 'UNKNOWN' TO CSC-RESULT-NAME
MACGEN        MOVE 24000 TO WS-COC-LENGTH.                                                    
                                                                                
           IF WS-COC-LENGTH > WS-MAX-DC-LENGTH                                  
               MOVE WS-MAX-DC-LENGTH TO WS-COC-LENGTH.                          
                                                                                
           IF CSC-RESULT-NAME NOT EQUAL 'UNKNOWN'                               
               MOVE MAP-BUFFER  TO SNA-VECTOR-DATA.                             
                                                                                
           MOVE WS-COC-LENGTH   TO SNA-BUFFER-LENGTH                            
                                   WS-ODC-LENGTH                                
                                   ADC-ODC-LENGTH.                              
           SET ADDRESS OF OUTPUT-DATA-CONTAINER                                 
            TO ADDRESS OF SNA-VECTOR-DATA.    
      * End of Screen Command                                                   
                                                                                
      ************** TRAILER: DFHMAL25 *********************************        
                                                                                

MACGEN     IF CSC-RESULT-NAME = 'ENDPAGE' THEN 
MACGEN       PERFORM 1120-PARAGRAPH THRU 1120-PARAGRAPH-EXIT
MACGEN     ELSE
MACGEN     IF CSC-RESULT-NAME = 'EXINQC' THEN 
MACGEN       PERFORM 1130-PARAGRAPH THRU 1130-PARAGRAPH-EXIT
MACGEN     ELSE
MACGEN       MOVE 'EXIT' TO NSC-RESULT-NAME
MACGEN       PERFORM 9000-NAVIGATOR-EXIT
MACGEN     END-IF.

       1110-PARAGRAPH-EXIT.
MACGEN     EXIT.

       1120-PARAGRAPH.

MACGEN* Mapping: Dfh0xs2.Exinqc_Exinqc

MACGEN* Mapping: loopEnd_variable0
MACGEN     
MACGEN     MOVE 'FALSE' TO VARIABLE0 OF
                V-CHECKITEMAVAILABILITY.

MACGEN     PERFORM 1060-PARAGRAPH THRU 1060-PARAGRAPH-EXIT.
       1120-PARAGRAPH-EXIT.
MACGEN     EXIT.

       1130-PARAGRAPH.

MACGEN* Mapping: Dfh0xs2.Exinqc_Exinqc

MACGEN     PERFORM 1060-PARAGRAPH THRU 1060-PARAGRAPH-EXIT.
       1130-PARAGRAPH-EXIT.
MACGEN     EXIT.
                                                                 
           COPY DFHMAL24.                                                       
                                                                                
      ************** TRAILER: DFHMAL20 *********************************        
                                                                                
